unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, GLWin32Viewer, GLScene, GLObjects, GLCoordinates, GLCrossPlatform,
  BaseClasses, GLMesh, StdCtrls, VectorTypes, GLColor, GLState;

type
  TForm1 = class(TForm)
    GLScene1: TGLScene;
    GLCamera1: TGLCamera;
    GLLightSource1: TGLLightSource;
    GLDummyCube1: TGLDummyCube;
    GLSceneViewer1: TGLSceneViewer;
    GLMesh1: TGLMesh;
    Button1: TButton;
    GLLightSource2: TGLLightSource;
    procedure FormCreate(Sender: TObject);
    procedure GLSceneViewer1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormMouseWheelUp(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    procedure FormMouseWheelDown(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    procedure GLSceneViewer1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
    px,py : integer;
    ss    : single;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  ss := GLCamera1.SceneScale;
end;

procedure TForm1.FormMouseWheelDown(Sender: TObject; Shift: TShiftState;
  MousePos: TPoint; var Handled: Boolean);
begin
  ss := ss - 0.05;
  if (ss<0.2) then ss := 0.2;
  GLCamera1.SceneScale := ss;
end;

procedure TForm1.FormMouseWheelUp(Sender: TObject; Shift: TShiftState;
  MousePos: TPoint; var Handled: Boolean);
begin
  ss := ss + 0.05;
  if (ss>3) then ss := 3;
  GLCamera1.SceneScale := ss;
end;

procedure TForm1.GLSceneViewer1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  px := X; py := Y;
end;

procedure TForm1.GLSceneViewer1MouseMove(Sender: TObject;
  Shift: TShiftState;
  X, Y: Integer);
begin
  if ssLeft in Shift then begin
    GLCamera1.MoveAroundTarget(py-Y,px-X);
    px := X; py := Y;
  end;
end;

// ejemplos con un Mesh
procedure TForm1.Button1Click(Sender: TObject);
var
  nor,
  v1,v2,v3,v4  : TVector3f;
  k,n          : integer;
  x1,x2,dx     : single;
  z,dz         : single;

  function curv(u:single):single;
  begin
    curv := 0.2*sin(2*pi*u);
  end;

begin
  GLMesh1.Vertices.Clear;

  nor[0] := 0; nor[1] := 0; nor[2] := 0;

  n := 32;

  dx := 4/(n-1);
  x1 := -2;
  x2 := -2 +dx;

  for k := 0 to n - 1 do begin

    v1[0] := x1; v1[1] :=  0.5; v1[2] := curv(x1);
    v2[0] := x1; v2[1] := -0.5; v2[2] := v1[2];
    v3[0] := x2; v3[1] :=  0.5; v3[2] := curv(x2);
    v4[0] := x2; v4[1] := -0.5; v4[2] := v3[2];

    // Caras frontales
    GLMesh1.Vertices.AddVertex(v1,nor,clrYellow) ;
    GLMesh1.Vertices.AddVertex(v2,nor,clrRed) ;
    GLMesh1.Vertices.AddVertex(v3,nor,clrBlue) ;

    GLMesh1.Vertices.AddVertex(v2,nor,clrGreen) ;
    GLMesh1.Vertices.AddVertex(v4,nor,clrWhite) ;
    GLMesh1.Vertices.AddVertex(v3,nor,clrRed) ;

    // Caras posteriores
    GLMesh1.Vertices.AddVertex(v1,nor,clrWhite) ;
    GLMesh1.Vertices.AddVertex(v3,nor,clrGray50) ;
    GLMesh1.Vertices.AddVertex(v2,nor,clrRed) ;

    GLMesh1.Vertices.AddVertex(v2,nor,clrGold) ;
    GLMesh1.Vertices.AddVertex(v3,nor,clrAqua) ;
    GLMesh1.Vertices.AddVertex(v4,nor,clrPink) ;

    x1 := x2;
    x2 := x2 + dx;
  end;


  GLMesh1.CalcNormals(fwCounterClockWise);
end;



end.
